<script setup lang="ts">
import { onMounted, ref } from 'vue'
import router from '@/router'
import _ from 'lodash'
import axios from 'axios'
import { QUERY_TYPES } from '@/utils/constants'
import { getFullEndPoint } from '@/utils/utilities'
import { useLoaderStore } from '@/stores/loader'
import { useSearchStore } from '@/stores/search'
import ModalDialog from '@/components/dialogs/ModalDialog.vue'
import OLLogo from '@/components/OLLogo.vue'
import SearchBox from '@/components/SearchBox.vue'

const loader = useLoaderStore()
const errorDialog = ref(false)

onMounted(() => {
  loader.hide()
})

const onSearch = async (e: string): Promise<void> => {
  const query = encodeURI(e)

  loader.show()
  try {
    const result = await axios.get(getFullEndPoint(query, QUERY_TYPES.TITLE))
    const { data } = result
    const searchStore = useSearchStore()
    searchStore.numFound = data.numFound
    searchStore.searchResults = _.take(data.docs, 10)

    router.push('/results')
  } catch (e) {
    loader.hide()
    errorDialog.value = true
  }
}
</script>

<template>
  <main>
    <div class="flex center" style="margin-bottom: 10px">
      <OLLogo />
      <span class="caption">Search</span>
    </div>
    <SearchBox @search="onSearch" />
    <ModalDialog :dialog="errorDialog" @close="errorDialog = false">
      <div style="padding-top: 30px">
        An error occurred while trying to fetch data
      </div>
    </ModalDialog>
  </main>
</template>

<style scoped>
main {
  width: 100%;
}
.caption {
  font-family: RobotoSlab;
  font-size: 1.6rem;
  margin-left: 10px;
  top: 15px;
}
</style>
